<?php defined('SYSPATH') or die('No direct script access.');

class Controller_DefaultTemplate extends Controller_Template
  {
     public $template = 'algemeen/default';

     /**
      * Initialize properties before running the controller methods (actions),
      * so they are available to our action.
      */
     public function before()
      {		 
         // Run anything that need ot run before this.
         parent::before();
		 
		 require_once('assets/FirePHPCore/fb.php');
		 # check valid login credentials
		 $vmi = Session::instance()->get('VMI', NULL);
		 

		 # set header content type for ajax requests
		 if ($this->request->is_ajax())
		 {
		   $this->profiler = NULL;
		   $this->auto_render = FALSE;
		   $this->response->headers('Content-Type','application/json');
			if (!isset($vmi['gebruiker']) && $this->request->method()=="GET") {
			 	$this->redirect("Login/login/ajax");
		   }
		} else {
		 	if ($this->request->Controller()!="Bevestig") {
				if($this->request->action()!="login"){
					if(!isset($vmi['gebruiker'])){
						$this->redirect("Login/login");
					} else if($vmi['gebruiker']=="bevestig"){
						$this->redirect("Login/login");
					}
				} else {
					if(isset($vmi['gebruiker']) && $vmi['gebruiker']!="bevestig"){
						if(empty($_SESSION['VMI']['last_request'])){
							$_SESSION['VMI']['last_request']="Leverancier/bestel";
						}
						$this->redirect($_SESSION['VMI']['last_request']);
					}
				}
				$_SESSION['VMI']['last_request']=$this->request->controller()."/".$this->request->action();
		 	}
		 }
		
         if($this->auto_render)
          {
            // Initialize empty values
            $this->template->title            = '';
            $this->template->meta_keywords    = '';
            $this->template->meta_description = '';
            $this->template->meta_copywrite   = '';
            $this->template->content          = '';
			$this->template->nav     		  = '';
            $this->template->styles           = array();
            $this->template->scripts          = array();
          }
      }

     /**
      * Fill in default values for our properties before rendering the output.
      */
     public function after()
      {
         if($this->auto_render)
          {
			  $v=Kohana::$config->load('appconf.version');
             // Define defaults
             $styles = array(
				'assets/css/jquery/jquery-ui.css?v='.$v => "screen",
				'assets/css/jquery/jquery.dataTables.css?v='.$v => "screen",
				'assets/css/jquery/chosen.css?v='.$v => "screen",
				'assets/css/jquery/jquery.qtip.css?v='.$v => "screen",
				'assets/css/font-awesome/css/font-awesome.css?v='.$v => "screen",
				'assets/css/default.css?v='.$v => 'screen',
             	'assets/css/style.css?v='.$v => 'screen');
			 
             $scripts = array(
			 	'assets/jquery/jquery.js?v='.$v,
				'assets/jquery/jquery-ui.js?v='.$v,
				'assets/jquery/jquery-ui-i18n.js?v='.$v,
				'assets/jquery/jquery.blockUI.js?v='.$v,
				'assets/jquery/jquery.dataTables.js?v='.$v,
				'assets/jquery/chosen.jquery.min.js?v='.$v,
				'assets/jquery/jquery.qtip.min.js?v='.$v,
				'assets/jquery/jquery.fileupload.js?v='.$v,
				'assets/jquery/jquery.iframe-transport.js?v='.$v,
				'assets/jquery/jquery.stayInWebApp.js?v='.$v,
				'assets/jquery/jquery.ui.touch-punch.js?v='.$v,
				'assets/includes/functies.js?v='.$v);
			 
             // Add defaults to template variables.
             $this->template->styles  = array_merge($styles, $this->template->styles);
             $this->template->scripts = array_merge($scripts, $this->template->scripts);
			 $this->template->title	 = "VMI";
           }

         // Run anything that needs to run after this.
         parent::after();
      }
 }
