<?php defined('SYSPATH') or die('No direct script access.');
 
/**
 * Custom exception handler for typical 404/500 error
 *
 * @author Lysender
 *
 */
class HTTP_Exception extends Kohana_HTTP_Exception
{
    /**
     * Generate a Response for all Exceptions without a more specific override
     *
     * The user should see a nice error page, however, if we are in development
     * mode we should show the normal Kohana error page.
     *
     * @return Response
     */
    public function get_response()
    {
        // Lets log the Exception, Just in case it's important!
        Kohana_Exception::log($this);
        if (Kohana::$environment >= Kohana::DEVELOPMENT)
        {
            // Show the normal Kohana error page.
            return parent::get_response();
        }
        else
        {
			if($this->getCode()==404){
				$title="Page not found";
				$content="<p>Het spijt ons. Deze pagina kan niet worden weergegeven omdat:</p>
							<ul>
								<li>De pagina is verplaatst</li>
    							<li>De pagina niet meer bestaat</li>
    							<li>Onze kikker ermee gaan lopen is</li>
							</ul>";
				// Generate a nicer looking "Oops" page.
            	$view = View::factory('error/error',array('errorstatus'=>$this->getCode(),'title'=>$title,'content'=>$content));
			} else {
				// Generate a nicer looking "Oops" page.
            	$view = View::factory('error/error',array('errorstatus'=>$this->getCode(),'title'=>Response::$messages[$this->getCode()],'content'=>$this->getMessage()));
			}

            $response = Response::factory()->status($this->getCode())->body($view->render());
 
            return $response;
        }
    }
}