<?php defined('SYSPATH') or die('No direct script access.');

class Model_Artikels extends Kohana_Model
{
	public function autoArtikel()
	{
		try{
			$sql = "SELECT art.artikelid as artikelid, ao.omschrijving as omschrijving,
			IF(art.verkoopseenheidtype=1,'ST','C') as verkoopseenheid, IF(art.verkoopseenheidtype=1,art.omverpakking,art.coefficient) as inhoud
					FROM artikel art
					LEFT JOIN artikelomschrijving ao ON ao.artikelid=art.artikelid AND ao.taalid=1
					WHERE (ao.omschrijving REGEXP :term OR art.artikelid REGEXP :term)
					ORDER BY ao.omschrijving; ";
			$query = DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':term'=>$_GET['term']));
			$db = $query->execute()->as_array();
			return $db;
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			return array();
		}
	}

	public function getArtikelPrijsInfo($artikelid,$levid,$prijs)
	{
		try{
			$sql = "SELECT l.leverancierid, l.naam as leverancier, la.artikelid, ao.omschrijving, IF(la.oververpakking=0,'','B') as oververpakking, art.coefficient,
					IF(ISNULL(art.aankoper),'GEEN AANKOPER',concat(c.voornaam,' ',c.naam))  as 'aankoper',
					IF(ISNULL(wga.winkelverkoopprijs),0,1) as '80artikel',
					ROUND(IFNULL(:prijs,IFNULL(la.prijs,0.00)),2) as 'aankoopprijs',
					ROUND(IFNULL(wga.winkelverkoopprijs,0.00),2) AS 'winkelverkoopprijs',
					ROUND(IFNULL(wga.winkelverkoopprijs/1.06/1.5,0.00),2) AS 'winkelverkoopprijs30',
					IF(la.oververpakking*art.coefficient=0,1,la.oververpakking*art.coefficient) as 'artcoefficient',
					IFNULL(ROUND(IF(la.oververpakking=0,wga.winkelverkoopprijs/1.06/1.5*0.85,wga.winkelverkoopprijs/1.06/1.5*0.85*art.coefficient) ,2),0.00)  AS 'bfmax',
					IFNULL(ROUND((((wga.winkelverkoopprijs/1.06)/1.5)-(IFNULL(ROUND(IFNULL(:prijs,IFNULL(la.prijs,0.00)),2)/(la.oververpakking*art.coefficient),ROUND(IFNULL(:prijs,IFNULL(la.prijs,0.00)),2))))/((wga.winkelverkoopprijs/1.06)/1.5)*100,2),0.00) as 'marge',
					IF(wga.winkelgroepid is null,'wit',
        				IF(IFNULL(ROUND((((wga.winkelverkoopprijs/1.06)/1.5)-(IFNULL(ROUND(IFNULL(:prijs,IFNULL(la.prijs,0.00)),2)/(la.oververpakking*art.coefficient),ROUND(IFNULL(:prijs,IFNULL(la.prijs,0.00)),2))))/((wga.winkelverkoopprijs/1.06)/1.5)*100,2),0.00)<10 ,'geel','wit')
        			) as 'margeclass'
					FROM leverancierartikel la
					LEFT JOIN artikel art ON la.artikelid=art.artikelid
					LEFT JOIN artikelomschrijving ao ON ao.artikelid=la.artikelid AND ao.taalid=1
					LEFT JOIN winkelgroepartikel wga ON wga.artikelid=la.artikelid AND wga.winkelgroepid=21
					LEFT JOIN leverancier l ON la.leverancierid=l.leverancierid
					LEFT JOIN contact c ON c.contactid=art.aankoper
					WHERE la.artikelid=:artikelid AND la.leverancierid=:levid ";
			$query = DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':artikelid'=>$artikelid,':levid'=>$levid,':prijs'=>floatval($prijs)));
			$db = $query->execute()->as_array();
			if(isset($db[0])){
				return $db[0];
			}else {
				return array();
			}
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			return array();
		}
	}


	public function getArtikelOrigine($datum)
	{
		try{
			$sql = "SELECT delorder.bestelid, delorder.artikelid, ao.omschrijving as artikelnaam, GROUP_CONCAT(DISTINCT delorder.country_of_origin ORDER BY delorder.country_of_origin) as landusys,
					GROUP_CONCAT(DISTINCT c.name_ab2 ORDER BY c.name_ab2) as landas400
					FROM wms_delivery d
					LEFT JOIN wms_delivery_order delorder ON d.deliveryid=delorder.deliveryid
					LEFT JOIN art_artikelorigine arto ON delorder.artikelid=arto.artikelid
					LEFT JOIN sl_country c ON c.countrycode=arto.origineid
					LEFT JOIN artikelomschrijving ao ON ao.artikelid=delorder.artikelid AND ao.taalid=1
					WHERE DATE(d.creation)=:datum AND country_of_origin is not null
					GROUP BY delorder.artikelid
					HAVING !FIND_IN_SET(GROUP_CONCAT(DISTINCT delorder.country_of_origin ORDER BY delorder.country_of_origin), GROUP_CONCAT(DISTINCT c.name_ab2 ORDER BY c.name_ab2))
					ORDER BY delorder.artikelid ";
			$query = DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':datum'=>$datum));
			$db = $query->execute()->as_array();
			return $db;
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			return array();
		}
	}

}
