<?php defined('SYSPATH') or die('No direct script access.');

class Model_Orders extends Kohana_Model
{

	public function getBestelling($bestelid)
	{
		try{
			$sql="SELECT b.bestelid, b.leverancierid, l.naam as leverancier, IFNULL(l.straatnr,'') as straatnr, IFNULL(l.postcode,'') as postcode, IFNULL(l.plaats,'') as plaats,
				b.registrator, c.naam, c.voornaam, b.depotid,
				b.datum,  b.bevestigd, b.bestelleveringvan, IF(b.controle=1,DATE(b.controledatum),IFNULL(b.leveringvan, b.bestelleveringvan)) as leveringvan, IF(b.controle=1,b.controledatum,'' ) as controledatum
				FROM bestellingleverancier b
				LEFT JOIN leverancier l ON b.leverancierid = l.leverancierid
				LEFT JOIN contact c ON c.contactid=b.registrator
				WHERE b.bestelid =:bestelid ;";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelid));
			$bestellingen=$query->execute()->as_array();

			foreach($bestellingen as $index => &$bestelling){
				//ARTIKELS
				$sql="SELECT bl.bestellingleverancierlijnid as lijnid, bl.bevestigd, bl.artikelid, ao.omschrijving, UPPER(la.code) as levcode,UPPER(la.informatie) as levomschrijving,
					ROUND(bl.prijs,2)as prijs ,ROUND(bl.prijsingegeven,2) as prijsingegeven,
					ROUND(bl.bestelaantal/bl.besteleenheden,0) as bestelaantal, bl.besteleenheden,
					ROUND(bl.aantal/bl.eenheden,0) as aantal, bl.eenheden, IF(la.oververpakking=0,'','B') AS 'oververpakking',
					IF(art.verkoopseenheidtype=1,'S','C') as handlingtype,
					ROUND(aantal/IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,IF(art.omverpakking=0,1,art.omverpakking),1),1),0) as kistenBesteld,
                    ROUND(aantal*IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,1,art.coefficient),1),0) as piecesBesteld,
                    IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,IF(art.omverpakking=0,1,art.omverpakking),art.coefficient),1) as ppcBesteld,
                    wms_qty_cases_accepted as kistenGeleverd, wms_qty_pieces_accepted as piecesGeleverd, IFNULL(ROUND(wms_qty_pieces_accepted/wms_qty_cases_accepted,2),0) as ppcGeleverd
					FROM bestellingleverancierlijn bl
					LEFT JOIN artikelomschrijving ao ON ao.artikelid=bl.artikelid AND ao.taalid=1
					LEFT JOIN leverancierartikel la ON la.artikelid=bl.artikelid AND la.leverancierid=:levid
					LEFT JOIN artikel art on art.artikelid=bl.artikelid
					WHERE bl.bestelid=:bestelid
					ORDER BY bl.artikelid ";
				$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelling['bestelid'],':levid'=>$bestelling['leverancierid']));
				$bestelling['artikels']=$query->execute()->as_array();

				//LEEGGOED
				$sql="SELECT l.leeggoedid, l.omschrijving, l.omschrijvingKort, IFNULL(ll.prijs,l.prijs) as prijs, bll.aantal
					FROM leverancierleeggoed ll
					LEFT JOIN leeggoed l on l.leeggoedid=ll.leeggoedid
					LEFT JOIN bestellingleverancierleeggoed bll ON bll.leeggoedid=ll.leeggoedid AND bll.bestelid=:bestelid
					WHERE ll.leverancierid=:levid
					ORDER BY l.volgnummer";
				$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelling['bestelid'],':levid'=>$bestelling['leverancierid']));
				$bestelling['leeggoed']=$query->execute()->as_array();

				//NOTA
				$sql="SELECT nota FROM bestellingleveranciernota WHERE bestelid=:bestelid";
				$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelling['bestelid']));
				$dbnota=$query->execute()->as_array();
				if(empty($dbnota)){
					$bestelling['nota']=$dbnota;
				}else{
					$bestelling['nota']=$dbnota[0]['nota'];
				}
			}
			return $bestellingen;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());
			return array();
		}
	}

	//Bestelling ophalen voor klacht registratie
	public function getBestelBon($levid, $artikelid)
	{
		try{
			$sql="SELECT b.bestelid, b.depotid, b.leveringvan, blijn.artikelid,
				ROUND(blijn.aantal/blijn.eenheden,0) as aantal,
				blijn.eenheden as eenheden, blijn.prijs,
				IFNULL((SELECT count(k.klachtid)
            		FROM klacht k
            		LEFT JOIN klachtartikel kart ON kart.klachtid=k.klachtid
           			WHERE kart.artikelid=:artikelid AND externe=:levid AND soort=1 and kart.levering=b.bestelid),0) as klachtid
				FROM bestellingleverancier b
				LEFT JOIN bestellingleverancierlijn blijn ON b.bestelid=blijn.bestelid
				WHERE b.leverancierid=:levid AND blijn.artikelid=:artikelid
				AND blijn.aantal is not null
				ORDER BY b.leveringvan desc LIMIT 10 ;";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':levid'=>$levid,':artikelid'=>$artikelid));
			$bestellingen=$query->execute()->as_array();
			return $bestellingen;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());
			return array();
		}
	}

	public function getManquant($datum)
	{
		try{
$sql="SELECT b.bestelid, b.leverancierid, l.naam as leveranciernaam, bl.artikelid, ao.omschrijving as artikelomschrijving,
					IF(art.verkoopseenheidtype=1,'S','C') as handlingtype,
					SUM(ROUND(bl.aantal/IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,IF(art.omverpakking=0,1,art.omverpakking),1),1),0)) as kistenBesteld,
                    SUM(ROUND(bl.aantal*IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,1,art.coefficient),1),0)) as piecesBesteld,
                    IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,IF(art.omverpakking=0,1,art.omverpakking),art.coefficient),1) as ppcBesteld,
                    SUM(wms_qty_cases_accepted) as kistenGeleverd, SUM(wms_qty_pieces_accepted) as piecesGeleverd,
					IFNULL(ROUND(SUM(wms_qty_pieces_accepted)/SUM(wms_qty_cases_accepted),2),'') as ppcGeleverd,
                    SUM(wms_qty_pieces_accepted)/SUM(wms_qty_cases_accepted) as ppcGeleverd2
					FROM bestellingleverancier b
					LEFT JOIN bestellingleverancierlijn bl ON bl.bestelid=b.bestelid
					LEFT JOIN artikel art ON art.artikelid=bl.artikelid
					LEFT JOIN artikelomschrijving ao ON ao.artikelid=bl.artikelid AND ao.taalid=1
					LEFT JOIN leverancier l on l.leverancierid=b.leverancierid
					WHERE b.leveringvan=:datum and b.controle=1 AND bl.aantal!=0
                    GROUP BY b.bestelid, bl.artikelid
                    HAVING kistenBesteld!=kistenGeleverd OR piecesBesteld!=piecesGeleverd OR ppcBesteld!=ppcGeleverd
					ORDER BY bl.artikelid, b.bestelid; ";

			/*$sql="SELECT b.bestelid, b.leverancierid, l.naam as leveranciernaam, bl.artikelid, ao.omschrijving as artikelomschrijving,
					IF(art.verkoopseenheidtype=1,'S','C') as handlingtype,
					ROUND(bl.aantal/IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,IF(art.omverpakking=0,1,art.omverpakking),1),1),0) as kistenBesteld,
                    ROUND(bl.aantal*IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,1,art.coefficient),1),0) as piecesBesteld,
                    IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,IF(art.omverpakking=0,1,art.omverpakking),art.coefficient),1) as ppcBesteld,
                    wms_qty_cases_accepted as kistenGeleverd, wms_qty_pieces_accepted as piecesGeleverd,
					IFNULL(ROUND(wms_qty_pieces_accepted/wms_qty_cases_accepted,2),'') as ppcGeleverd
					FROM bestellingleverancier b
					LEFT JOIN bestellingleverancierlijn bl ON bl.bestelid=b.bestelid
					LEFT JOIN artikel art ON art.artikelid=bl.artikelid
					LEFT JOIN artikelomschrijving ao ON ao.artikelid=bl.artikelid AND ao.taalid=1
					LEFT JOIN leverancier l on l.leverancierid=b.leverancierid
					WHERE b.leveringvan=:datum and b.controle=1
					AND (
						ROUND(bl.aantal/IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,IF(art.omverpakking=0,1,art.omverpakking),1),1),0)!=wms_qty_cases_accepted
						OR ROUND(bl.aantal*IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,1,art.coefficient),1),0)!=wms_qty_pieces_accepted
						OR IF(art.eenheid=1,IF(art.verkoopseenheidtype=1,IF(art.omverpakking=0,1,art.omverpakking),art.coefficient),1)!=IFNULL(ROUND(wms_qty_pieces_accepted/wms_qty_cases_accepted,2),0)
					) AND bl.aantal!=0
					ORDER BY bl.artikelid, b.bestelid;";*/
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':datum'=>$datum));
			$bestellingen=$query->execute()->as_array();
			return $bestellingen;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());
			return array();
		}
	}

	public function setOrder($geg)
	{
		try{
			$mailsturen=TRUE;
			if(isset($geg['mailsturen']) && $geg['mailsturen']==0){
				$mailsturen=FALSE;
			}
			$nota= str_replace('\n', '<br />', $geg['nota']);
			$nota=trim($nota);

			$artikels=array();
			if(isset($geg['artikels'])){
				$artikels=$geg['artikels'];
			}
			$leeggoed=array();
			if(isset($geg['leeggoed'])){
				$leeggoed=$geg['leeggoed'];
			}
			$levid=$_SESSION['VMI']['slLev'];
			$leverdatum=$geg['leverdatum'];
			//controleren of er bestelling is anders enkel nota versturen
			if(!empty($artikels)){
				Database::instance()->begin();
				//bestelling in database plaatsen
				$insert = DB::insert('bestellingleverancier')
								->columns(array('leverancierid', 'leveranciergroepid','datum','registrator','bestelleveringvan','leveringvan','bevestigd'))
								->values(array($levid,0,date('Y-m-d H:i:s'),$_SESSION['VMI']['contactid'],$leverdatum,$leverdatum,0));
				$result = $insert->execute();
				$bestelid=$result[0];

				//artikels in bestellinglijn plaatsen
				foreach($artikels as $artikel){
					//update prijs leverancier
					$sql="UPDATE leverancierartikel
							SET prijs=:prijs, actief=1
							WHERE leverancierid=:levid AND artikelid=:artikelid";
					$query = DB::query(Database::UPDATE, $sql, FALSE)
								->parameters(array(':prijs'=>$artikel['prijsingegeven'],
										':levid'=>$levid,
										':artikelid'=>$artikel['artikelid']))->execute();

					//berekende prijs ophalen
					/*$sql="SELECT ROUND((IF(lart.korting>0,
								(1-lart.korting/100)*(IF(lart.oververpakking=1,(lart.prijs/art.coefficient),lart.prijs ) ),
								IF(lart.oververpakking=1,(lart.prijs/art.coefficient),lart.prijs) ))+IFNULL(lart.kost,0),2) as prijs
							FROM leverancierartikel lart
							LEFT JOIN artikel art ON art.artikelid=lart.artikelid
							WHERE lart.leverancierid=:levid AND lart.artikelid=:artikelid";*/
				$sql="SELECT ROUND(IF(lart.oververpakking=1,(lart.prijs/ IF(art.verkoopseenheidtype=1,art.omverpakking,art.coefficient)),lart.prijs) + IFNULL(lart.kost,0),2) as prijs
									FROM leverancierartikel lart
									LEFT JOIN artikel art ON art.artikelid=lart.artikelid
									WHERE lart.leverancierid=:levid AND lart.artikelid=:artikelid";

					$db = DB::query(Database::SELECT, $sql, FALSE)
							->parameters(array(':levid'=>$levid,
										':artikelid'=>$artikel['artikelid']))->execute();
					$prijs=$db[0]['prijs'];

					//artikels in bestellingleverancierlijn plaatsen
					$sql="INSERT INTO bestellingleverancierlijn
							(bestelid, artikelid, bestelaantal, besteleenheden, aantal, eenheden, prijs, prijsingegeven, coefficient)
							SELECT :bestelid, :artikelid, :bestelaantal, :besteleenheden, :aantal, :eenheden, :prijs, :prijsingegeven, coefficient FROM artikel WHERE artikelid=:artikelid";
					$query = DB::query(Database::INSERT, $sql, FALSE)
								->parameters(array(':bestelid'=>$bestelid,
										':artikelid'=>$artikel['artikelid'],
										':bestelaantal'=>$artikel['aantal']*$artikel['eenheden'],
										':besteleenheden'=>$artikel['eenheden'],
										':aantal'=>$artikel['aantal']*$artikel['eenheden'],
										':eenheden'=>$artikel['eenheden'],
										':prijs'=>$prijs,
										':prijsingegeven'=>$artikel['prijsingegeven']))->execute();
				}

				//leeggoed toevoegen
				if(!empty($leeggoed)){
					foreach($leeggoed as $lg){
						if($lg['aantal']>0){
							//INSERT BESTELLING LEVERANCIER LEEGGOED
							$sql="INSERT INTO bestellingleverancierleeggoed (bestelid, leeggoedid, aantal) VALUES (:bestelid, :leeggoedid, :aantal)";
							$query = DB::query(Database::INSERT, $sql, FALSE)
									->parameters(array(':bestelid'=>$bestelid,
										':leeggoedid'=>$lg['leeggoedid'],
										':aantal'=>$lg['aantal']))->execute();
						}
					}
				}

				//nota in bestellingleveranciernota plaatsen
				if(!empty($nota)){
					$nota="++++".date('Y-m-d H:i:s')."++++<br/>".$nota."<br/>";
					$insert = DB::insert('bestellingleveranciernota')
									->columns(array('bestelid', 'nota'))
									->values(array($bestelid,$nota));
					$result = $insert->execute();
				}

				//LEVERANCIER FICHE OPHALEN
				$mdl=new Model_Leverancier();
				$leverancier=$mdl->getFicheLeverancier($levid);

				if($leverancier['bevestigd']==0 || $_SESSION['VMI']['gebruiker']=='leverancier' ){
					//ALS op FICHE leverancier bevestigd sta of leverancier besteld zelf bevestigen.
					//bestelling bevestigen
					$sql="UPDATE bestellingleverancier SET bevestigd=1 WHERE bestelid=:bestelid ";
					DB::query(Database::UPDATE, $sql, FALSE)->parameters(array(':bestelid'=>$bestelid))->execute();
				}


				//winkelmandje verwijderen
				$sql="DELETE FROM leverancierwinkelmandje WHERE leverancierid=:levid AND contactid=:contactid;";
				DB::query(Database::DELETE, $sql, FALSE)->parameters(array(':levid'=>$levid,':contactid'=>$_SESSION['VMI']['contactid']))->execute();

				Database::instance()->commit();

				//EDI BESTELLING DOORSTUREN
				//if($leverancier['edi']==1 && $mailsturen){
				//	$soap= new Model_Soap();
				//	$soap->startEDI_Univeg_SetOrder($bestelid);
				//}

				//gegevens klaarmaken om mail te sturen
				$tomail=Kohana::$config->load('appconf.tomail');

				$mdlLev= new Model_Leverancier();
				if($mailsturen){
					$contacten=$mdlLev->getContactenLeverancierMail($levid,1);
					$tomail.=",".$contacten['mail'];
				}
				//$contacten=$mdlLev->getContactenLeverancierMail($levid,1);
				//$tomail.=",".$contacten['mail'];



				if($leverancier['bevestigd']==0 || $_SESSION['VMI']['gebruiker']=='leverancier' ){
					//Levering OPHALEN
					$mdl=new Model_Leveringen();
					$levering=$mdl->getLevering($bestelid);
					$mdl=new Model_Mail();
					$mdl->setSubject("[DESADV: ".$levering['leveringid']."] ".$levering['leverancierid']. " ".$levering['leverancier']);
					$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
					$response=$mdl->mailDesadv($levering,$nota);

					if(!empty($transport['mail']) && $mailsturen){
						$mdl=new Model_Mail();
						$mdl->setSubject("[DESADV: ".$levering['leveringid']."] ".$levering['leverancierid']. " ".$levering['leverancier']);
						$mdl->setTo(array_unique(explode(",",rtrim($contacten['mail'],","))));
						$mdl->mailDesadvTransport($levering,$nota);
					}
				} else {
					//bestelling ophalen
					$bestelling=$this->getBestelling($bestelid);
					$mdl=new Model_Mail();
					$mdl->setSubject("[ORDER: ".$bestelling[0]['bestelid']."] ".$bestelling[0]['leverancierid']. " ".$bestelling[0]['leverancier']);
					$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
					$response=$mdl->mailBestelling($bestelling[0],$nota);

					//TRANSPORT MAIL
					if(!empty($transport['mail']) && $mailsturen){
						$mdl=new Model_Mail();
						$mdl->setSubject("[ORDER: ".$bestelling[0]['bestelid']."] ".$bestelling[0]['leverancierid']. " ".$bestelling[0]['leverancier']);
						$mdl->setTo(array_unique(explode(",",rtrim($contacten['mail'],","))));
						$mdl->mailBestellingTransport($bestelling[0],$nota);
					}
				}

			}elseif(!empty($nota)){
				Database::instance()->begin();
				//lege bestelling in database plaatsen meteen bevestigen en compleet
				$insert = DB::insert('bestellingleverancier')
								->columns(array('leverancierid', 'leveranciergroepid','datum','registrator','opgehaald','leveringvan','bevestigd','controle','controledatum'))
								->values(array($levid,0,date('Y-m-d H:i:s'),$_SESSION['VMI']['contactid'],1,$leverdatum,1,1,date('Y-m-d H:i:s')));
				$result = $insert->execute();
				$bestelid=$result[0];

				$nota="++++".date('Y-m-d H:i:s')."++++<br/>".$nota."<br/><hr/>";
				$insert = DB::insert('bestellingleveranciernota')
								->columns(array('bestelid', 'nota'))
								->values(array($bestelid,$nota));
				$result = $insert->execute();
				Database::instance()->commit();

				//gegevens klaarmaken om mail te sturen
				$tomail=Kohana::$config->load('appconf.tomail');

				$mdlLev= new Model_Leverancier();
				if($mailsturen){
					$contacten=$mdlLev->getContactenLeverancierMail($levid,1);
					$tomail.=",".$contacten['mail'];
				}
				$leverancier=$mdlLev->getFicheLeverancier($levid);
				$mdl=new Model_Mail();
				$mdl->setSubject("[NOTA AANKOOP] ".$leverancier['leverancierid']. " ".$leverancier['naam']);
				$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
				$response=$mdl->mailNota($leverancier, $nota);

			}else{
				$response['success']=true;
				$response['titel']="Info";
				$response['message']="LET OP! Er zijn geen bestelgegevens of nota gevonden! ";
			}

		}catch(Exception $e){
			//Database::instance()->rollback();
			$response['success'] = false;
			$response['titel']="Error";
			$response['message'] = $e->getMessage();
			Log::instance()->add(Log::ERROR, $e->getMessage());
		}
		return $response;
	}
	//Bestelling in bestelling tabel toevoegen die gemaakt is door een aankoper
	//enkel indivueele leveranciers
	/*public function setOrderLeverancier($geg)
	{
		try{
			$mailsturen=TRUE;
			if(isset($geg['mailsturen']) && $geg['mailsturen']==0){
				$mailsturen=FALSE;
			}
			$nota= str_replace('\n', '<br />', $geg['nota']);
			$nota=trim($nota);

			$artikels=array();
			if(isset($geg['artikels'])){
				$artikels=$geg['artikels'];
			}
			$levid=$_SESSION['VMI']['slLev'];
			$leverdatum=$geg['leverdatum'];
			//controleren of er bestelling is anders enkel nota versturen
			if(!empty($artikels)){
				Database::instance()->begin();
				//bestelling in database plaatsen
				$insert = DB::insert('bestellingleverancier')
    						->columns(array('leverancierid', 'leveranciergroepid','datum','registrator','bestelleveringvan','leveringvan','bevestigd'))
    						->values(array($levid,0,date('Y-m-d H:i:s'),$_SESSION['VMI']['contactid'],$leverdatum,$leverdatum,0));
				$result = $insert->execute();
				$bestelid=$result[0];

				//artikels in bestellinglijn plaatsen
				foreach($artikels as $artikel){
					//update prijs leverancier
					$sql="UPDATE leverancierartikel
							SET prijs=:prijs, actief=1
							WHERE leverancierid=:levid AND artikelid=:artikelid";
					$query = DB::query(Database::UPDATE, $sql, FALSE)
								->parameters(array(':prijs'=>$artikel['prijsingegeven'],
										':levid'=>$levid,
										':artikelid'=>$artikel['artikelid']))->execute();

					//berekende prijs ophalen
					$sql="SELECT ROUND((IF(lart.korting>0,
								(1-lart.korting/100)*(IF(lart.oververpakking=1,(lart.prijs/art.coefficient),lart.prijs ) ),
								IF(lart.oververpakking=1,(lart.prijs/art.coefficient),lart.prijs) ))+IFNULL(lart.kost,0),2) as prijs
							FROM leverancierartikel lart
							LEFT JOIN artikel art ON art.artikelid=lart.artikelid
							WHERE lart.leverancierid=:levid AND lart.artikelid=:artikelid";
					$db = DB::query(Database::SELECT, $sql, FALSE)
							->parameters(array(':levid'=>$levid,
										':artikelid'=>$artikel['artikelid']))->execute();
					$prijs=$db[0]['prijs'];

					//artikels in bestellingleverancierlijn plaatsen
					$sql="INSERT INTO bestellingleverancierlijn
							(bestelid, artikelid, bestelaantal, besteleenheden, aantal, eenheden, prijs, prijsingegeven, coefficient)
							SELECT :bestelid, :artikelid, :bestelaantal, :besteleenheden, :aantal, :eenheden, :prijs, :prijsingegeven, coefficient FROM artikel WHERE artikelid=:artikelid";
					$query = DB::query(Database::INSERT, $sql, FALSE)
								->parameters(array(':bestelid'=>$bestelid,
										':artikelid'=>$artikel['artikelid'],
										':bestelaantal'=>$artikel['aantal']*$artikel['eenheden'],
										':besteleenheden'=>$artikel['eenheden'],
										':aantal'=>$artikel['aantal']*$artikel['eenheden'],
										':eenheden'=>$artikel['eenheden'],
										':prijs'=>$prijs,
										':prijsingegeven'=>$artikel['prijsingegeven']))->execute();
				}

				//nota in bestellingleveranciernota plaatsen
				if(!empty($nota)){
					$nota="++++".date('Y-m-d H:i:s')."++++<br/>".$nota."<br/>";
					$insert = DB::insert('bestellingleveranciernota')
    							->columns(array('bestelid', 'nota'))
    							->values(array($bestelid,$nota));
					$result = $insert->execute();
				}
				//winkelmandje verwijderen
				$sql="DELETE FROM leverancierwinkelmandje WHERE leverancierid=:levid AND groepid=:groepid;";
				DB::query(Database::DELETE, $sql, FALSE)->parameters(array(':levid'=>$levid,':groepid'=>0))->execute();

				Database::instance()->commit();
				//bestelling ophalen
				$bestelling=$this->getBestelling($bestelid);

				//EDI BESTELLING DOORSTUREN
				$mdl=new Model_Leverancier();
				$leverancier=$mdl->getFicheLeverancier($levid);
				if($leverancier['edi']==1){
					$soap= new Model_Soap();
					$soap->startEDI_Univeg_SetOrder($bestelid);
				}

				//gegevens klaarmaken om mail te sturen
				$tomail=Kohana::$config->load('appconf.tomail');

				$mdlLev= new Model_Leverancier();
				if($mailsturen){
					$contacten=$mdlLev->getContactenLeverancierMail($bestelling[0]['leverancierid'],1);
					$tomail.=",".$contacten['mail'];
				}
				$mdl=new Model_Mail();
				$mdl->setSubject("[ORDER: ".$bestelling[0]['bestelid']."] ".$bestelling[0]['leverancierid']. " ".$bestelling[0]['leverancier']);
				$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
				$response=$mdl->mailBestelling($bestelling[0],$nota);

				//Transport contact ophalen
				$contacten=$mdlLev->getContactenLeverancierMail($bestelling[0]['leverancierid'],4);
				if(!empty($contacten['mail'])){
					$mdl=new Model_Mail();
					$mdl->setSubject("[ORDER: ".$bestelling[0]['bestelid']."] ".$bestelling[0]['leverancierid']. " ".$bestelling[0]['leverancier']);
					$mdl->setTo(array_unique(explode(",",rtrim($contacten['mail'],","))));
					$mdl->mailBestellingTransport($bestelling[0],$nota);
				}

			}elseif(!empty($nota)){
				Database::instance()->begin();
				//lege bestelling in database plaatsen meteen bevestigen en compleet
				$insert = DB::insert('bestellingleverancier')
    						->columns(array('leverancierid', 'leveranciergroepid','datum','registrator','opgehaald','leveringvan','bevestigd','controle','controledatum'))
    						->values(array($levid,0,date('Y-m-d H:i:s'),$_SESSION['VMI']['contactid'],1,$leverdatum,1,1,date('Y-m-d H:i:s')));
				$result = $insert->execute();
				$bestelid=$result[0];

				$nota="++++".date('Y-m-d H:i:s')."++++<br/>".$nota."<br/><hr/>";
				$insert = DB::insert('bestellingleveranciernota')
    						->columns(array('bestelid', 'nota'))
    						->values(array($bestelid,$nota));
				$result = $insert->execute();
				Database::instance()->commit();

				//gegevens klaarmaken om mail te sturen
				$tomail=Kohana::$config->load('appconf.tomail');

				$mdlLev= new Model_Leverancier();
				if($mailsturen){
					$contacten=$mdlLev->getContactenLeverancierMail($levid,1);
					$tomail.=",".$contacten['mail'];
				}
				$leverancier=$mdlLev->getFicheLeverancier($levid);
				$mdl=new Model_Mail();
				$mdl->setSubject("[NOTA AANKOOP] ".$leverancier['leverancierid']. " ".$leverancier['naam']);
				$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
				$response=$mdl->mailNota($leverancier, $nota);

			}else{
				$response['success']=true;
				$response['titel']="Info";
				$response['message']="LET OP! Er zijn geen bestelgegevens of nota gevonden! ";
			}

		}catch(Exception $e){
			Database::instance()->rollback();
			$response['success'] = false;
			$response['titel']="Error";
			$response['message'] = $e->getMessage();
			Log::instance()->add(Log::ERROR, $e->getMessage());
		}
		return $response;
	}
*/
	//Plaatsen van een bestelling door leverancier
	//Deze wordt ook meteen bevestigd
/*	public function setOrderDesadvLeverancier($geg)
	{
		try{
			Database::instance()->begin();
			$nota= str_replace('\n', '<br />', $geg['nota']);
			$nota=trim($nota);

			$artikels=array();
			if(isset($geg['artikels'])){
				$artikels=$geg['artikels'];
			}
			$leeggoed=array();
			if(isset($geg['leeggoed'])){
				$leeggoed=$geg['leeggoed'];
			}
			$levid=$_SESSION['VMI']['slLev'];
			$leverdatum=$geg['leverdatum'];

			if(!empty($artikels)){
				//bestelling in database plaatsen
				$sql="INSERT INTO bestellingleverancier (leverancierid, leveranciergroepid,  datum, registrator, leveringvan, bevestigd )
						VALUES (:leverancierid, 0, CURRENT_TIMESTAMP(), 22, :leveringvan, 0 )";
				$query = DB::query(Database::INSERT, $sql, FALSE)->parameters(array(':leverancierid'=>$levid,':leveringvan'=>$leverdatum));
				$insert=$query->execute();
				$bestelid=$insert[0];

				//artikels in bestelling lijn plaatsen
				foreach($artikels as $artikel){
					//prijs update
					$sql="UPDATE leverancierartikel
							SET prijs=:prijs
							WHERE leverancierid=:levid AND artikelid=:artikelid";
					$query = DB::query(Database::UPDATE, $sql, FALSE)
							->parameters(array(':prijs'=>$artikel['prijsingegeven'],
										':levid'=>$levid,
										':artikelid'=>$artikel['artikelid']))->execute();

					//berekende prijs ophalen
					$sql="SELECT ROUND(IF(lart.oververpakking=1,(lart.prijs/art.coefficient),lart.prijs),2) as prijs
							FROM leverancierartikel lart
							LEFT JOIN artikel art ON art.artikelid=lart.artikelid
							WHERE lart.leverancierid=:levid AND lart.artikelid=:artikelid";
					$db = DB::query(Database::SELECT, $sql, FALSE)
							->parameters(array(':levid'=>$levid,
										':artikelid'=>$artikel['artikelid']))->execute();
					$prijs=$db[0]['prijs'];



					//artikel in bestellinglijn plaatsen
					$sql="INSERT INTO bestellingleverancierlijn (bestelid, artikelid, aantal, eenheden, prijs, prijsingegeven,coefficient)
							SELECT :bestelid, :artikelid, :aantal, :eenheden, :prijs, :prijsingegeven, coefficient FROM artikel WHERE artikelid=:artikelid ";
					$query = DB::query(Database::INSERT, $sql, FALSE)
							->parameters(array(':bestelid'=>$bestelid,
										':artikelid'=>$artikel['artikelid'],
										':aantal'=>$artikel['aantal']*$artikel['eenheden'],
										':eenheden'=>$artikel['eenheden'],
										':prijs'=>$prijs,
										':prijsingegeven'=>$artikel['prijsingegeven']));
					$insert=$query->execute();

				}

				//leeggoed toevoegen
				if(!empty($leeggoed)){
					foreach($leeggoed as $lg){
						if($lg['aantal']>0){
							//INSERT BESTELLING LEVERANCIER LEEGGOED
							$sql="INSERT INTO bestellingleverancierleeggoed (bestelid, leeggoedid, aantal) VALUES (:bestelid, :leeggoedid, :aantal)";
							$query = DB::query(Database::INSERT, $sql, FALSE)
									->parameters(array(':bestelid'=>$bestelid,
										':leeggoedid'=>$lg['leeggoedid'],
										':aantal'=>$lg['aantal']))->execute();
						}
					}
				}

				//NOTA
				if(!empty($nota)){
					$nota="++++".date('Y-m-d H:i:s')."++++<br/>".$nota."<br/>";
					$insert = DB::insert('bestellingleveranciernota')
    						->columns(array('bestelid', 'nota'))
    						->values(array($bestelid,$nota));
					$result = $insert->execute();
				}

				//bestelling bevestigen
				$sql="UPDATE bestellingleverancier SET bevestigd=1 WHERE bestelid=:bestelid ";
				DB::query(Database::UPDATE, $sql, FALSE)->parameters(array(':bestelid'=>$bestelid))->execute();

				//winkelmandje verwijderen
				$sql="DELETE FROM leverancierwinkelmandje WHERE leverancierid=:levid AND groepid=:groepid;";
				DB::query(Database::DELETE, $sql, FALSE)->parameters(array(':levid'=>$levid,':groepid'=>0))->execute();

				//Levering OPHALEN
				$mdl=new Model_Leveringen();
				$levering=$mdl->getLevering($bestelid);

				//EDI BESTELLING DOORSTUREN
				$mdl=new Model_Leverancier();
				$leverancier=$mdl->getFicheLeverancier($levid);
				if($leverancier['edi']==1){
					$soap= new Model_Soap();
					$soap->startEDI_Univeg_SetOrder($bestelid);
				}

				//gegevens klaarmaken om mail te sturen
				$tomail=Kohana::$config->load('appconf.tomail');

				$mdlLev= new Model_Leverancier();
				$contacten=$mdlLev->getContactenLeverancierMail($levering['leverancierid'],1);
				$tomail.=",".$contacten['mail'];

				$mdl=new Model_Mail();
				$mdl->setSubject("[DESADV: ".$levering['leveringid']."] ".$levering['leverancierid']. " ".$levering['leverancier']);
				$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
				$response=$mdl->mailDesadv($levering,$nota);

				//Transport contact ophalen
				$contacten=$mdlLev->getContactenLeverancierMail($levering['leverancierid'],4);
				if(!empty($contacten['mail'])){
					$mdl=new Model_Mail();
					$mdl->setSubject("[DESADV: ".$levering['leveringid']."] ".$levering['leverancierid']. " ".$levering['leverancier']);
					$mdl->setTo(array_unique(explode(",",rtrim($contacten['mail'],","))));
					$mdl->mailDesadvTransport($levering,$nota);
				}
			}elseif(!empty($nota)){
				//lege bestelling in database plaatsen meteen bevestigen en compleet
				$insert = DB::insert('bestellingleverancier')
    						->columns(array('leverancierid', 'leveranciergroepid','datum','registrator','opgehaald','leveringvan','bevestigd','controle','controledatum'))
    						->values(array($levid,0,date('Y-m-d H:i:s'),$_SESSION['id'],1,$leverdatum,1,1,date('Y-m-d H:i:s')));
				$result = $insert->execute();
				$bestelid=$result[0];

				$nota="++++".date('Y-m-d H:i:s')."++++<br/>".$nota."<br/>";
				$insert = DB::insert('bestellingleveranciernota')
    						->columns(array('bestelid', 'nota'))
    						->values(array($bestelid,$nota));
				$result = $insert->execute();

				//bestelling ophalen
				$bestelling=$this->getBestelling($bestelid);

				//mail sturen
				//gegevens klaarmaken om mail te sturen
				$tomail=Kohana::$config->load('appconf.tomail');

				$mdlLev= new Model_Leverancier();
				if($mailsturen){
					$contacten=$mdlLev->getContactenLeverancierMail($bestelling[0]['leverancierid'],1);
					$tomail.=",".$contacten['mail'];
				}
				$leverancier=$mdlLev->getFicheLeverancier($levid);
				$mdl=new Model_Mail();
				$mdl->setSubject("[NOTA AANKOOP] ".$leverancier['leverancierid']. " ".$leverancier['naam']);
				$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
				$response=$mdl->mailNota($leverancier, $nota);
			}else{
				$response['success']=true;
				$response['titel'] = "Info";
				$response['message']="LET OP! Er zijn geen bestelgegevens of nota gevonden! ";
			}
			Database::instance()->commit();
		}catch(Exception $e){
			Database::instance()->rollback();
			$response['success'] = false;
			$response['titel'] = "Error";
			$response['message'] = $e->getMessage();
			Log::instance()->add(Log::ERROR, $e->getMessage());
		}
		return $response;
	}*/

	public function setOrderPrijs($geg)
	{
		try{
			Database::instance()->begin();
			$bestelid=$geg['bestelid'];
			$artikels=$geg['artikels'];
			fb($geg);

			//artikels in bestellinglijn plaatsen
			foreach($artikels as $artikel){
				//artikels prijzen in bestellingleverancierlijn plaatsen
				$sql="UPDATE bestellingleverancierlijn SET prijs=:prijs WHERE bestelid=:bestelid AND artikelid=:artikelid AND bestellingleverancierlijnid=:lijnid ";
				$query = DB::query(Database::INSERT, $sql, FALSE)
								->parameters(array(':bestelid'=>$bestelid,
										':artikelid'=>$artikel['artikelid'],
										':lijnid'=>$artikel['lijnid'],
										':prijs'=>$artikel['prijs']))->execute();

			}
			Database::instance()->commit();
			$response['success'] = true;
			$response['titel']="Info";
			$response['message'] = "Prijzen zijn aangepast.";
		}catch(Exception $e){
			Database::instance()->rollback();
			$response['success'] = false;
			$response['titel']="Error";
			$response['message'] = $e->getMessage();
			Log::instance()->add(Log::ERROR, $e->getMessage());
		}
		return $response;
	}

	public function getDataBestellingen()
	{
		$aColumns = array(
			array( 'db' => 'bestelid', 'dt' => 'bestelid' ),
			array( 'db' => 'leverancierid',  'dt' => 'leverancierid' ),
			array( 'db' => 'leverancier',   'dt' => 'leverancier' ),
			array( 'db' => 'leveranciergroepid',  'dt' => 'leveranciergroepid' ),
			array(
				'db'        => 'depotid',
				'dt'        => 'depotid',
				'formatter' => function( $d, $row ) {
					if($d==1){
						return 'Olen';
					} else if($d==2){
						return 'St-Katelijne-Waver';
					} else {
						return $d;
					}
				}
			),
			array(
				'db'        => 'besteldatum',
				'dt'        => 'besteldatum',
				'formatter' => function( $d, $row ) {
					return strftime('%H:%M %A, %d  %B \'%y',strtotime($d));
				}
			),
			array(
				'db'        => 'leveringvan',
				'dt'        => 'leveringvan',
				'formatter' => function( $d, $row ) {
					return strftime('%A, %d  %B \'%y',strtotime($d));
				}
			),
			array( 'db' => 'bevestigd',   'dt' => 'bevestigd' ),
			array( 'db' => 'opgehaald',   'dt' => 'opgehaald' ),
			array( 'db' => 'controledatum',   'dt' => 'controledatum' ),
			array( 'db' => 'usys',   'dt' => 'usys' )
		);
		$sIndexColumn = "bestelid";
		$sTable = " vwLeverancierBestellingen ";
		$output = SSPdataTables::dataTables($aColumns,$sIndexColumn,$sTable);
		return $output;
	}


}
