<?php defined('SYSPATH') or die('No direct script access.');

class Model_Winkelmandje extends Kohana_Model
{
	public function setMandje($geg)
	{
		$winkelmandjeid=0;
		try{
			//eerst kijken of aantal is ingevuld
			if($geg['aantal']==0 && $geg['eenheden']==0){
				//kijken al in winkelmandje
				if($geg['winkelmandjeid']!=0){
					//delete
					$sql="DELETE FROM leverancierwinkelmandje WHERE winkelmandjeid=:winkelmandjeid;";
					DB::query(Database::DELETE, $sql, FALSE)
						->parameters(array(':winkelmandjeid'=>$geg['winkelmandjeid']))->execute();
				}
			}else{
				if($geg['eenheden']==0){ $geg['eenheden']=1; }
				if($geg['aantal']==0){ $geg['aantal']=1; }
				//kijken al in winkelmandje
				if($geg['winkelmandjeid']==0){
					//insert
					if(!empty($geg['artikelid']) && !empty($geg['prijs'])){
						$sql="INSERT INTO leverancierwinkelmandje (leverancierid, contactid, artikelid, aantal, eenheden, prijs)
							VALUES (:leverancierid, :contactid,:artikelid, :aantal, :eenheden, :prijs)";
						$insert=DB::query(Database::INSERT, $sql, FALSE)
							->parameters(array(':leverancierid'=>$geg['levid'],
							':contactid'=>$_SESSION['VMI']['contactid'],
							':artikelid'=>$geg['artikelid'],
							':aantal'=>$geg['aantal'],
							':eenheden'=>$geg['eenheden'],
							':prijs'=>$geg['prijs']))->execute();
						$winkelmandjeid=$insert[0];
					}
				}else{
					//update
					$sql="UPDATE leverancierwinkelmandje SET aantal=:aantal, eenheden=:eenheid, prijs=:prijs
							WHERE winkelmandjeid=:winkelmandjeid;";
					DB::query(Database::UPDATE, $sql, FALSE)
						->parameters(array(':aantal'=>$geg['aantal'],':eenheid'=>$geg['eenheden'],':prijs'=>$geg['prijs'],':winkelmandjeid'=>$geg['winkelmandjeid']))->execute();
					$winkelmandjeid=$geg['winkelmandjeid'];
				}
			}

			//kijken is artikel bij leverancier bekend
			//CHECK BESTAAT 202
			$mdl=new Model_LeverancierArtikels();
			$mdl->checkNieuwArtikel($geg['levid'], $geg['artikelid']);

			$response['success']=true;
			$response['winkelmandjeid']=$winkelmandjeid;
			$response['message']="Gegevens zijn opgeslagen.";
		} catch(Exception $e) {
			$response['winkelmandjeid']=$winkelmandjeid;
			$response['success'] = false;
			$response['message'] = $e->getMessage();
			Log::instance()->add(Log::ERROR, $e->getMessage());
		}
		return $response;
	}
}
