// JavaScript Document
$.blockUI.defaults.baseZ=1020;
$(document).ajaxStop($.unblockUI);
$(function(){
	/* BLOCK UI DEFAULTS */
	$.blockUI.defaults.message=$('#block-message');
	$.blockUI.defaults.overlayCSS.backgroundColor='#DCE5E8';
	$.blockUI.defaults.overlayCSS.opacity=0.6;
	$.blockUI.defaults.css.backgroundColor='#FFFFFF';
	$.blockUI.defaults.css.border='3px solid #CFE58C';
	$.blockUI.defaults.css.width='20%';
	$.blockUI.defaults.css.padding='10px';
	$.blockUI.defaults.css.left='40%';
	$.blockUI.defaults.css.color='#CFE58C';

	/* DATA TABLES DEFAULT */
	$.extend( $.fn.dataTable.defaults, {
		"displayLength": 15,
		"lengthChange": false,
		"pagingType": "full_numbers",
		"processing": true,
        "serverSide": true,
		"language": {
            "url": "../../assets/includes/dataTables_nl.txt"
        }
	});

	/* DATE PICKER DEFAULTS */
	$.datepicker.setDefaults( $.datepicker.regional[ "nl-BE" ] );

	$('select').chosen({
		allow_single_deselect: true,
		no_results_text: "Geen resultaten gevonden",
   	 	placeholder_text_single: "Selecteer een optie",
    	placeholder_text_multiple: "Selecteer verschillende opties"
	});

	$('#selectlev').change(function(){
		$.post("../Functies/setSessLeverancier", {
			'leverancierid':$('#selectlev').val()
		}, function(response){
			window.location=location;
		});
	});

	$('#selectaankoper').change(function(){
		$.post("../Functies/setSessAankoper", {
			'aankoperid':$('#selectaankoper').val()
		}, function(response){
			window.location=location;
		});
	});

	$('#selectzone').change(function(){
		$.post("../Functies/setSessZone", {
			'zoneid':$('#selectzone').val()
		}, function(response){
			window.location=location;
		});
	});

	$('#selectgroep').change(function(){
		$.post("../Functies/setSessGroep", {
			'groepid':$('#selectgroep').val()
		}, function(response){
			window.location=location;
		});
	});

	//voor makkelijkere navigatie
	$("body").on("click", "li", function(){
		if($(this).find('a').attr('href') && !($(this).find('a').attr('href').substring(0, 1) == "#")){
			window.location=$(this).find('a').attr('href');
		}
	});

	//voorkomen dat formulier submit bij klikken enter
	$("body").on('keypress','form',function (e) {
		var code = e.keyCode || e.which;
		var node = (e.target) ? e.target : ((e.srcElement) ? e.srcElement : null);
		if(code==13 && node.type!="textarea" && $(e.target).parents('form').attr('id')!="frmLogin"){//13:enter
			return false;
		}
	});

	//NAV => keydown
	$("body").on('keydown','input.nav',function(e){
		var code = e.keyCode || e.which;
		//navigatie
		if(code==39){
			//keypress arrow right:volgende kolom
			$(this).closest('td').next().find('input').focus().select();
			return false;
		}else if (code==37){
			//keypress arrow left:vorige kolom
			$(this).closest('td').prev().find('input').focus().select();
			return false;
		}else if (code == 13 || code==40) {
			//keypress enter/arrow down: volgende rij
			$(this).closest('tr').next().find('input[name='+$(this).attr('name')+']').focus().select();
			return false;
		}else if (code==38){
			//keypress arrow up: vorige rij
			$(this).closest('tr').prev().find('input[name='+$(this).attr('name')+']').focus().select();
			return false;
		} else if (code==9){
			//keypress tag: volgend input veld
			$('input.nav:eq(' + ($('input.nav').index(this) + 1) + ')').focus().select();
			return false;
		}
	});

	//check value => keypress
	$("body").on('keypress','input.getal, input.decimal',function(e){
		var code = e.keyCode || e.which;
		var pressedvalue = String.fromCharCode(code);
		//enkel cijfers
		if($(this).hasClass('getal')){
			if(code!=8 && code!=0 && (code<48 || code>57)) {
		    	return false;
			}
		}
		if($(this).hasClass('decimal')){
			//decimal komma's en punten toelaten
			if(code!=8 && code!=0 && code!=46 && code!=44 && (code<48 || code>57)) {
		    	return false;
			}
			//comma vervangen door punt
			if(code==44){
				$(this).val($(this).val()+".");
				return false;
			}
		}
		//max input (999)
		var maxinput = $(this).attr("max");

		if (($(this).hasClass('decimal') || $(this).hasClass('getal')) && (parseInt(this.value+pressedvalue) >= parseInt(maxinput)))
		{
			$(this).val(pressedvalue);
			return false;
		}
	});

	//ARTIKEL INFO POPUP
	$("body").on('click touchstart','#content.g_aankoper a.artikelinfo',function(event){
		event.preventDefault();
		var artikelid=$(this).attr('data-artikelid');
		var levid=$(this).attr('data-levid');
		var prijsing=0.00;
		if($(this).closest('tr').find('input[name=prijsingegeven]').val()!=undefined){
			prijsing=$(this).closest('tr').find('input[name=prijsingegeven]').val();
		}  else if ($(this).closest('tr').find('input[name=prijs]').val()!=undefined){
			prijsing=$(this).closest('tr').find('input[name=prijs]').val();
		}
		var titel='Artikel Fiche';

		//create dialog
		$("<div />").dialog({
			open: function(event, ui){
				$('body').addClass('stop-scrolling');
				$(this).load("../Functies/getArtikelinfo?artid="+artikelid+"&levid="+levid+"&prijs="+prijsing);
			},
			close: function(event, ui){
				$('body').removeClass('stop-scrolling');
				$(this).dialog('destroy').remove()
			},
			title:titel,
			autoOpen: true,
			resizable: false,
			draggable:false,
			height: 400,
			width: 400,
			draggable:false,
			modal: true
		});
	});
});

// show dialog message
function showMsg(title, message, dorefresh)
{
	$("#dialog-message").html(message);
	if(title){
		$("#dialog-message").attr('title',title);
	}
	$("#dialog-message").dialog({
		open:function(event,ui){
			$('body').addClass('stop-scrolling');
		},
		close:function(event,ui){
			$('body').removeClass('stop-scrolling');
		},
		autoOpen: true,
		modal: true,
		draggable:false,
		resizable:false,
		buttons: {
			OK: function() {
				if(dorefresh){
					window.location=location;
				}
				$(this).dialog("close");
			}
		}
    });
}
//AUTO COMPLETE ARTIKEL
function maakAutoArtikel(){
	$( ".autoartikel" ).autocomplete({
	    source: "../Functies/autocompleteArtikel",
	    select: function( event, ui ) {
				$(this).closest('tr').attr('data-artikelid',ui.item.artikelid);
				$(this).closest('tr').find('input[name=artikelid]').val(ui.item.artikelid);
				$(this).closest('tr').find('.artikelid').val(ui.item.artikelid);
				$(this).closest('tr').find('.infoartikelid').html(ui.item.artikelid);
				$(this).closest('tr').find('.verkoopseenheid').html(ui.item.verkoopseenheid);
				$(this).closest('tr').find('.inhoud').html(ui.item.inhoud);

				$(this).val(ui.item.omschrijving);
				return false;
   		}
	});
	$.each($( ".autoartikel" ), function(index, item) {
        $(item).data("ui-autocomplete")._renderItem = function (ul, item) {
        	return $("<li></li>")
             .data( "item.autocomplete", item )
			.append("<a><div><table style='width: 230px;'><tr style='text-align: left;'><td style='width: 30px;'>" + item.artikelid + "</td><td style='width: 200px;'>" + item.omschrijving + "</td></tr></table></div></a>")
			.appendTo( ul );
        };
    });
}

//AUTO COMPLETE LEVERANCIER
function maakAutoLeverancier(){
	$(".lev").autocomplete({
		source : "../Functies/autocompleteLeverancier",
		select : function(event, ui) {
			$(this).closest('tr').find('.levid').val(ui.item.id);
			$(this).val(ui.item.naam);
			return false;
		}
	});
	$.each($( ".lev" ), function(index, item) {
        $(item).data("ui-autocomplete")._renderItem = function (ul, item) {
        	return $( "<li></li>" )
				.data( "item.autocomplete", item )
				.append("<a><div><table style='width: 230px;'><tr style='text-align: left;'><td style='width: 30px;'>" + item.id + "</td><td style='width: 200px;'>" + item.naam + "</td></tr></table></div></a>")
				.appendTo( ul );
        };
    });
}

function maakQtipLeeggoed(){
	$("a.leeggoedfoto").qtip({
		content: {
			text: function(){
					var leeggoedid = $(this).attr('data-lgid');
					var lgomschrijving = $(this).attr('data-lgomschr');
					return "<img src='../../assets/images/leeggoed/lg"+leeggoedid+".png' />";
			},
			title: {
				text: function(){
					var lgomschrijving = $(this).attr('data-lgomschr');
					return lgomschrijving;
				},
				button: true
			},
		},
		position:{
			at: 'left center',
			my: 'right center',
			viewport: $(window),
			effect: false
		},
		show:{
			event: 'click',
			solo: true
		},
		hide:'unfocus',
		style: {
				 classes: 'qtip-light qtip-shadow'
		}
	});
}
function generate_random(lengte){
	var upper = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	var lower = "abcdefghijklmnopqrstuvwxyz"
	var number = "0123456789"
	var seed_length=42;
	var seed=upper+lower+number;
	var rand=0;
	var password="";
	for (var i=0; i < lengte; i++) {
 		rand=Math.floor(Math.random()*seed_length);
	 	password += seed.substr(rand,1);
	}
	return password;
}

function StartDecimalMetPunt(decimal)
{
	decimal=decimal.replace(",",".");
	var x = decimal.substr(0,1);
	if (x == "." ) {
		return "0" + decimal;
	} else {
		return decimal;
	}
}

//override val functie voor textarea om new line te printen.
$.valHooks.textarea = {
	get: function( elem ) {
		elem.value.replace("&nbsp;", " " );
		return elem.value.replace( /\r?\n/g, "<br/>" );
	}
};

/* Eigen Functie om serialize te groeperen en naar object om te zetten */
$.fn.serializeGroupObject = function()
{
    var o = {};
    var a = this.serializeArray();
	var first=a[0].name;
	var key=-0;
    $.each(a, function() {
		//replace , door . om in DB te plaatsen
		this.value = this.value.replace(",", ".");
		if(this.name==first){
			key++;
			o[key] = {};
		}
        if (o[key][this.name] !== undefined) {
            if (!o[key][this.name].push) {
                o[key][this.name] = [o[key][this.name]];
            }
           	 o[key][this.name].push(this.value || null);
        } else {
            o[key][this.name] = this.value || null;
       	 }
   	 });
    return o;
};


/* Eigen Functie om enkel bevestig lijnen  */
function partBevestig(art)
{
    var o = {};
	var key=0;
	$.each(art, function() {
		if(this.bevestig!=null){
			o[key] = {};
			o[key] = this;
			key++;
		}
   	 });
    return o;
};

/* Eigen Functie om lege lijnen te verwijderen */
function deleteEmpties(art)
{
    var o = {};
	var key=0;
	$.each(art, function() {
		if(this.aantal!=null || this.eenheden!=null){
			if(this.aantal==null){
				this.aantal=1;
			}
			if(this.eenheden==null){
				this.eenheden=1;
			}
			o[key] = {};
			o[key] = this;
			key++;
		}
   	 });
    return o;
};

function deleteEmptieContacten(contact)
{
    var o = {};
	var key=0;
	$.each(contact, function() {
		if(Object.keys(this).length>1){
			o[key] = {};
			o[key] = this;
			key++;
		}
   	 });
    return o;
};

$.fn.getData = function() {
	var o = {};
	var a = this.serializeArray();
	var multiple=false;
	$.each(a, function() {
		if(!this.name.match("van$") && !this.name.match("tot$") && !this.name.match("actief$")){
			if($("[name="+this.name+"]").hasClass('decimal')){
				this.value=StartDecimalMetPunt(this.value);
			}
			if($("[name="+this.name+"]").attr('multiple') || $("[name="+this.name+"]").hasClass('multiple')){
				multiple=true;
			} else {
				multiple=false;
			}
			var temp={};
			temp.val=this.value;
			temp.oudval=$("[name="+this.name+"]").attr('data-oud');
			temp.kolomid=$("[name="+this.name+"]").attr('data-kolomid');
			if($("[name="+this.name+"]").attr('data-extraid')){
				temp.extraid=$("[name="+this.name+"]").attr('data-extraid');
				temp.extranaam=$("[name="+this.name+"]").attr('data-extranaam');
			}
			temp.multiple=multiple;
			if($("[name="+this.name+"]").hasClass('periode')){
				temp.van=$("[name="+this.name+"van]").val();
				temp.tot=$("[name="+this.name+"tot]").val();
				if($("[name="+this.name+"actief]").is(":checked")){
					temp.actief=1;
				}else{
					temp.actief=0;
				}
			}
			if(multiple){
				if (o[this.name] !== undefined) {
					if(o[this.name].val !== ""){
						o[this.name].val=o[this.name].val+","+temp.val;
					} else {
						o[this.name].val=temp.val;
					}
        		} else {
            		o[this.name] = temp || null;
       			}
			}else{
				o[this.name] = temp ;
			}
		}
	});
	return o;
};

$.fn.getGroepData = function() {
	var o = {};
	var key=0;
	this.find('tbody > tr').each(function() {
		var row={};
		if($(this).find('input[name=artikelid]')!=undefined || $(this).find('input[name=leveranciercontactid]')!=undefined){
			$(this).find('input').each(function(){
				if($(this).attr('name')!=undefined){
					if($(this).attr('data-oud')!=$(this).val() || $(this).attr('name')=="artikelid" || $(this).attr('name')=="leveranciercontactid"){
						var temp={};
			 			temp.val=$(this).val();
			 			temp.oudval=$(this).attr('data-oud');
			 			temp.kolomid=$(this).attr('data-kolomid');
             			row[$(this).attr('name')]=temp;
					}
				}
       	 	});
			o[key]=row;
			key++;
		}
	});
    return o;
};
