<?php
require_once('assets/pdf/fpdf/fpdf.php');
class DesadvPDF extends FPDF{
	var $gegevens;
	var $orderid;

	function setGegevens($geg) {
 		$this->gegevens = $geg;
	}
	
	function Header()
	{
		$this->SetLeftMargin(25);
		$this->SetRightMargin(15);
		$this->AddFont('Calibri','','calibri.php');
		$this->AddFont('Calibri','I','calibrii.php');
		$this->AddFont('Calibri','B','calibrib.php');
		$this->AddFont('CalibriLight','I','calibrili.php');
		
		$this->SetTextColor(64,64,64);
		$header=$this->gegevens;
		# header image
		$this->Image('assets/images/GREENYARD_RGB_32.png',25,10);
		$this->SetTextColor(51,102,51);
		$this->SetDrawColor(51,102,51);
		$this->Cell(62,9,"",'B',1,"L");
		$this->SetFont('Calibri','',11);
		$this->Cell(0,6,"Greenyard Fresh Direct Belgium NV",0,1,"L");
		
		$this->SetXY(140,10);
		$this->SetFont('CalibriLight','I',22);
		$this->Cell(20,6,"Fresh",0,1,"L");
		$this->Ln(10);

		# header info
		$this->SetFont('Calibri','',8);
		$this->SetTextColor(51,102,51);
		$this->Cell(100,4,"Fortsesteenweg 27 / BE-2860 Sint-Katelijne-Waver / Belgium",0,0,"L");
		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(64,64,64);
		$this->Cell(30,4,$header['leverancier']." (".$header['leverancierid'].")",0,1,"L");
		$this->SetFont('Calibri','',8);
		$this->SetTextColor(51,102,51);
		$this->Cell(100,4,"T +32 15 32 48 00 / F +32 15 32 48 08",0,0,"L");
		$this->SetFont('Calibri','',10);
		$this->SetTextColor(64,64,64);
		$this->Cell(30,4,$header['straatnr'],0,1,"L");
		$this->SetFont('Calibri','',8);
		$this->SetTextColor(51,102,51);
		$this->Cell(100,4,"info.direct@greenyardfresh.be",0,0,"L");
		$this->SetFont('Calibri','',10);
		$this->SetTextColor(64,64,64);
		$this->Cell(30,4,$header['postcode']." ".$header['plaats'],0,1,"L");
		$this->Ln(1);
			
		$this->SetTextColor(64, 64, 64);
        $this->SetFont('Calibri', '', 8);
		$this->Cell(0,3,'p '.$this->PageNo().'/{nb}',0,0,'R');
		$this->Ln(1);
		
		//INFO TABEL
		$this->SetDrawColor(180);
		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(64,64,64);
		$this->Cell(0,5,"Desadv",0,1,"L");
		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(51,102,51);

		$w=array(42, 42, 43, 43);
		$this->Cell($w[0],5,"Order",1,0,"C");
		$this->Cell($w[1],5,"Delivery",1,0,"C");
		$this->Cell($w[2],5,"Purchaser",1,0,"C");
		$this->Cell($w[3],5,"Order creation",1,1,"C");
		$this->SetFont('Calibri','',10);
		$this->SetTextColor(64,64,64);
		$this->Cell($w[0],5,$header['bestelid'],1,0,"C", false);
		$this->Cell($w[1],5,date('d/m/Y', strtotime($header['leveringvan'])),1,0,"C", false);
		$this->Cell($w[2],5,$header['voornaam']." ".$header['naam'],1,0,"C", false);
		$this->Cell($w[3],5,date('d/m/Y H\hi', strtotime($header['datum'])),1,0,"C", false);
		$this->Ln(8);

		$this->orderid=$header['bestelid'];
		$this->SetDrawColor(180);
		$this->SetTextColor(64,64,64);
	}
	
	function Footer()
	{
		$header=$this->gegevens;
		$this->SetTextColor(64, 64, 64);
        $this->SetFont('Calibri', '', 10);
        $this->SetY(-20);
		$this->Cell(0,6,"VMI Desadv from order ".$this->orderid,0,0,"L");
		
		$this->Image('assets/images/GY_FAHF_darkgreen_RGB_600x67.png',155,277,43);
        $this->Image('assets/images/gy_line_1200x6.png',10,285,190);
		
	}	
	
	function InfoTabel($info)
	{
		$this->SetDrawColor(180);
		$this->SetTextColor(64,64,64);
		
		$this->SetFont('Calibri','B',10);
		$this->MultiCell(0,5,"INFO:",0,"L");
		$this->Ln();
		$this->SetFont('Calibri','',10);
		$this->MultiCell(0,5,strip_tags(utf8_decode($info)),0,"L");
		$this->Ln();
	}
	
	function LeveringTabel($gegevens)
	{
		$h=5;
		$this->SetDrawColor(180);

		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(64,64,64);
		$this->Cell(0,$h,"Artikels",0,1,"L");
		
		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(51,102,51);
		$w=array(16,60,60,17,17);
		$header=array("Code","Omschrijving","Code Leverancier","Aantal","EH");
		for($i=0; $i<count($header); $i++){
			$this->Cell($w[$i],$h,$header[$i],1,0,"C");
		}
		$this->Ln();
		$this->SetFont('Calibri','',10);
		$this->SetTextColor(64,64,64);
		foreach($gegevens['artikels'] as $i=>$artikel){
			if($this->GetY()+15>$this->PageBreakTrigger){
				$this->addPage();
				$this->SetFont('Calibri','B',10);
				$this->SetTextColor(64,64,64);
				$this->Cell(0,$h,"Artikels",0,1,"L");
				
				$this->SetFont('Calibri','B',10);
				$this->SetTextColor(51,102,51);
				for($i=0; $i<count($header); $i++){
					$this->Cell($w[$i],$h,$header[$i],0,0,"C");
					
				}
				$this->Ln();
				$this->SetFont('Calibri','',10);
				$this->SetTextColor(64,64,64);
			}	
			$this->Cell($w[0],$h,$artikel['artikelid'],1,0,"R");
			$this->Cell($w[1],$h,utf8_decode($artikel['omschrijving']),1,0,"L");
			$this->Cell($w[2],$h,utf8_decode($artikel['levcode']." ".$artikel['levomschrijving']),1,0,"L");
			$this->Cell($w[3],$h,$artikel['aantal'],1,0,"R");
			$this->Cell($w[4],$h,$artikel['eenheden'],1,0,"R");
			$this->Ln();
		}
		$this->Ln(5);
		
		/*$this->Cell(30,5,"BIO OK",1,0,"C");
		$this->Cell(30,5,"TEMP OK",1,1,"C");
		$this->Cell(30,5," ",1,0,"C");
		$this->Cell(30,5," ",1,1,"C");
		$this->Ln(5);*/
	}
	

	function LeeggoedTabel($leeggoed)
	{
		$this->SetDrawColor(180);
		
		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(64,64,64);
		$this->Cell(0,5,"Leeggoed",0,1,"L");
		
		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(51,102,51);
		$this->Cell(15,5,"Aantal",1,0,"R");
		$this->Cell(70,5,"Omschrijving",1,1,"L");

		$this->SetFont('Calibri','',10);
		$this->SetTextColor(64,64,64);
		foreach($leeggoed as $i=>$lg){	
			$this->Cell(15,5,$lg['aantal'],1,0,"R");
			$this->Cell(70,5,utf8_decode($lg['omschrijving']),1,1,"L");
		}
		$this->Ln(5);
	}

	
}
?>