<?php
require_once('assets/pdf/fpdf/fpdf.php');
class KlachtPDF extends FPDF{
	var $gegevens;

	function setGegevens($geg) {
 		$this->gegevens = $geg;
	}
	
	function Header()
	{
		$this->SetLeftMargin(25);
		$this->SetRightMargin(15);
		$this->AddFont('Calibri','','calibri.php');
		$this->AddFont('Calibri','I','calibrii.php');
		$this->AddFont('Calibri','B','calibrib.php');
		$this->AddFont('CalibriLight','I','calibrili.php');
		
		$this->SetTextColor(64,64,64);
		$header=$this->gegevens;
		# header image
		$this->Image('assets/images/GREENYARD_RGB_32.png',25,10);
		$this->SetTextColor(51,102,51);
		$this->SetDrawColor(51,102,51);
		$this->Cell(62,9,"",'B',1,"L");
		$this->SetFont('Calibri','',11);
		$this->Cell(0,6,"Greenyard Fresh Direct Belgium NV",0,1,"L");
		
		$this->SetXY(140,10);
		$this->SetFont('CalibriLight','I',22);
		$this->Cell(20,6,"Fresh",0,1,"L");
		$this->Ln(10);
		
		# header info
		if ($this->page == 1) {
			$this->SetFont('Calibri','',8);
			$this->SetTextColor(51,102,51);
			$this->Cell(100,4,"Fortsesteenweg 27 / BE-2860 Sint-Katelijne-Waver / Belgium",0,0,"L");
			$this->SetFont('Calibri','B',10);
			$this->SetTextColor(64,64,64);
			$this->Cell(30,4,$header['leverancier']." (".$header['leverancierid'].")",0,1,"L");
			$this->SetFont('Calibri','',8);
			$this->SetTextColor(51,102,51);
			$this->Cell(100,4,"T +32 15 32 48 00 / F +32 15 32 48 08",0,0,"L");
			$this->SetFont('Calibri','',10);
			$this->SetTextColor(64,64,64);
			$this->Cell(30,4,$header['straatnr'],0,1,"L");
			$this->SetFont('Calibri','',8);
			$this->SetTextColor(51,102,51);
			$this->Cell(100,4,"info.direct@greenyardfresh.be",0,0,"L");
			$this->SetFont('Calibri','',10);
			$this->SetTextColor(64,64,64);
			$this->Cell(30,4,$header['postcode']." ".$header['plaats'],0,1,"L");
			$this->Ln(1);
			
			$this->SetTextColor(64, 64, 64);
         	$this->SetFont('Calibri', '', 8);
			$this->Cell(0,3,'p '.$this->PageNo().'/{nb}',0,0,'R');
			$this->Ln(1);
			
			//INFO TABEL
			$this->SetDrawColor(180);
			$this->SetFont('Calibri','B',10);
			$this->SetTextColor(64,64,64);
			$this->Cell(0,4,"Quality Assessment",0,1,"L");
			
			$this->SetFont('Calibri','B',10);
			$this->SetTextColor(51,102,51);
			$w=array(56, 57, 57);
			$this->Cell($w[0],5,"Assessment",1,0,"C");
			$this->Cell($w[1],5,"Assessed by",1,0,"C");
			$this->Cell($w[2],5,"Assessment creation",1,1,"C");
			
			$this->SetFont('Calibri','',10);
			$this->SetTextColor(64,64,64);
			$this->Cell($w[0],5,$header['klachtid'],1,0,"C");
			$this->Cell($w[1],5,"Quality Fresh Direct",1,0,"C");
			$this->Cell($w[2],5,date('d/m/Y', strtotime($header['aangemaakt'])),1,0,"C");
			$this->Ln(8);
		} else {
			$this->SetTextColor(64, 64, 64);
         	$this->SetFont('Calibri', '', 8);
			$this->Cell(0,3,'p '.$this->PageNo().'/{nb}',0,0,'R');
			$this->Ln();
		}
		
		$this->SetDrawColor(180);
		$this->SetTextColor(64,64,64);
	}

	function Footer()
	{
		$header=$this->gegevens;
		$this->SetTextColor(64, 64, 64);
        $this->SetFont('Calibri', '', 8);
        $this->SetY(-20);
		
		$this->Image('assets/images/GY_FAHF_darkgreen_RGB_600x67.png',155,277,43);
        $this->Image('assets/images/gy_line_1200x6.png',10,285,190);
		
	}
	
	function InfoTabel($info)
	{
		$this->SetDrawColor(180);
		$this->SetTextColor(64,64,64);
		
		$this->SetFont('Calibri','B',10);
		$this->Cell(0,5,"Extra",0,1,"L");
		$this->Ln(1);
		$this->SetFont('Calibri','',10);
		$this->MultiCell(0,5,strip_tags(utf8_decode($info)),0,"L");
		$this->Ln();
	}
	
	function ImgTabel($docs)
	{
		$this->SetDrawColor(180);
		$this->SetTextColor(64,64,64);
		
		$docsA = explode(",",$docs);
		foreach($docsA as $d){
			$ext = pathinfo($d, PATHINFO_EXTENSION);
			$validextensions=array('jpeg','jpg','png');
			$valid=in_array($ext,$validextensions);
            if($valid){
				$this->Image('assets/upload/'.$d);
				$this->Ln(5);
			}
		}
	}
	
	
	function KlachtTabel($gegevens)
	{
		$h=5;
		$this->SetDrawColor(180);
		$this->SetTextColor(64,64,64);

		$this->SetFont('Calibri','B',10);
		$this->Cell(0,$h,"Detail",0,1,"L");
		

		$w=array(15,55,55,15,15,15);
		$header=array("Code","Omschrijving","Code Leverancier","Prijs","Aantal","EH");
		

		$this->Ln();
		$this->SetFont('Calibri','',10);
		foreach($gegevens as $i=>$artikel){
			if($i>0){
				$this->Cell(0,$h,"",'B',1,"R");
			 	$this->Ln(3);
			}
			
			if($this->GetY()+40>$this->PageBreakTrigger){
				$this->addPage();
			}
			$this->SetFont('Calibri','B',10);
			$this->SetTextColor(64,64,64);
			$this->Cell(30,$h,"Order",0,0,"L");
			$this->SetFont('Calibri','',10);
			$this->Cell(40,$h,$artikel['levering'],0,0,"L");
			$this->SetFont('Calibri','B',10);
			$this->Cell(15,$h,"Reden",0,0,"L");
			$this->SetFont('Calibri','',10);
			$this->Cell(30,$h,$artikel['reden'],0,0,"L");
			$this->Ln();
			$this->SetFont('Calibri','B',10);
			$this->Cell(30,$h,"Nr Leverancier",0,0,"L");
			$this->SetFont('Calibri','',10);
			$this->Cell(40,$h,$artikel['levleveringsnr'],0,0,"L");
			$this->SetFont('Calibri','B',10);
			$this->Cell(15,$h,"Actie",0,0,"L");
			$this->SetFont('Calibri','',10);
			$this->Cell(30,$h,$artikel['actie'],0,0,"L");
			$this->Ln();
			$this->SetFont('Calibri','B',10);
			$this->Cell(30,$h,"Delivery Date",0,0,"L");
			$this->SetFont('Calibri','',10);
			$this->Cell(40,$h,date('d/m/Y',strtotime($artikel['leveringvan'])),0,0,"L");
			$this->SetFont('Calibri','B',10);
			$this->Cell(15,$h,"Status",0,0,"L");
			$this->SetFont('Calibri','',10);
			$this->Cell(30,$h,$artikel['status'],0,0,"L");
			$this->Ln();
			
			$this->SetFont('Calibri','B',10);
			$this->Cell(0,$h,"Artikel",0,1,"L");
			
			$this->SetFont('Calibri','B',10);
			$this->SetTextColor(51,102,51);
			for($i=0; $i<count($header); $i++){
				$this->Cell($w[$i],$h,$header[$i],1,0,"C");
			}
			$this->Ln();
			$this->SetFont('Calibri','',10);
			$this->SetTextColor(64,64,64);

			$this->Cell($w[0],$h,$artikel['artikelid'],1,0,"R");
			$this->Cell($w[1],$h,$artikel['artikelomschrijving'],1,0,"L");
			$this->Cell($w[2],$h,$artikel['artikellev'],1,0,"L");
			$this->Cell($w[3],$h,chr(128).' '.$artikel['prijs'],1,0,"R");
			$this->Cell($w[4],$h,$artikel['aantalstuks'],1,0,"R");
			$this->Cell($w[5],$h,$artikel['eenheid'],1,0,"R");
			
			$this->Ln();
			
		}
	}
	
	function LeeggoedTabel($leeggoed)
	{
		$this->SetDrawColor(180);
		
		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(64,64,64);
		$this->Cell(0,5,"Leeggoed",0,1,"L");
		$this->Ln(2);
		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(51,102,51);
		$this->Cell(70,5,"Omschrijving",1,0,"L");
		$this->Cell(21,5,"Prijs",1,0,"R");
		$this->Cell(22,5,"Aantal",1,1,"R");

		$this->SetFont('Calibri','',10);
		$this->SetTextColor(64,64,64);
		foreach($leeggoed as $i=>$lg){	
			$this->Cell(70,5,utf8_decode($lg['omschrijving']),1,0,"L");
			$this->Cell(21,5,chr(128).' '.$lg['prijs'],1,0,"R");
			$this->Cell(22,5,$lg['aantalstuks'],1,1,"R");
		}
		$this->Ln(5);
	}
}
?>
